
package server;

import service.*;

// Change start
import net.jini.core.event.*;
import java.util.Vector;
import java.rmi.RemoteException;
// Change end

public class EchoImpl implements Echo {
    // Change start  
    private Vector listeners = new Vector(); 
    private int seqNum = 0; // event sequence counter
    private String text = "";
    // Change end
    
    public EchoImpl() {
    }

    public String echo(String in) {
	// Change start
	fireNotify(TEXT_CHANGED);
	text = in;
	// Change end

	return "Echo: " + in;
    }

    // Change start
    public String getChangedText() {
	return text;
    }
    // Change end

    // Change start  
    public EventRegistration addEventListener(RemoteEventListener listener) { 
	listeners.add(listener); 
	return new EventRegistration(0L, this, null, 0L);
    }
    // Change end

    // Change start 
    protected void fireNotify(long eventID) { 
	RemoteEvent remoteEvent = new RemoteEvent(this, eventID, seqNum++, null); 
	for (int n = 0; n < listeners.size(); n++) { 
	    RemoteEventListener listener = (RemoteEventListener) listeners.elementAt(n); 
	    try { 
		listener.notify(remoteEvent); 
	    } catch(UnknownEventException e) { 
		// ignore 
	    } catch(RemoteException e) { 
		// ignore 
	    } 
	}
    }
    // Change end
}
